* JB_FIND
*
* pjwitte 2o2o+
* All code is my own work except as and where stated
*
* V0.01
*
* Compatible with SMSQ/E, and with Qdos/Minerva only if compiled!
*
* It may be theoretically possble to end up with a job ID of $FFFFFFF9 (-7)
* but its highly unlikely..


        section code

        xdef JB_FIND

        xref l2frtrd6

        include dev8_keys_sbasic
        include dev8_keys_qdos_sms
        include dev8_keys_qlv


*
JB_FIND
* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
* Find a job
*
* job_id = JB_FIND("<job name>")
*
* Given a job name, return its ID or -7
*
* All of the TK2 JOB/JB commands error if a named job does not exist. Eg
* JOB$(<job ID>) is fine with a non-existent ID, but not with a non-
* existent name. Thus, the simplest way to check whether a named job exists
* is to use JB_FIND.
*
* JB_FIND("") will ALWAYS return 0, even though it may be asleep or for
* some unfathonable reason not exist.
*

        move.w sb.gtstr,a2
        jsr (a2)
        bne.s exit

        subq.w #1,d3
        bne.s err_bp

        moveq #0,d6
        move.w (a6,a1.l),d6     len = 0? ie System
        beq.s found             should always be present..

        move.w #$4afb,d4        job flag
        moveq #0,d1
        movea.l a1,a3           a3 -> string

loop
        move.l d1,d6            save this job ID
        moveq #0,d2             job at top of tree
        moveq #sms.injb,d0
        trap #do.smsq

        lea.l 6(a0),a0
        cmp.w (a0)+,d4
        bne.s loop              dont understand this job header..

        movea.l a3,a1           point to parameter (job name)
        move.w ut.cstr,a2
        moveq #utc.ncas,d0      case indifferent
        suba.l a6,a0            make a6 relative (Qdos compatible? No.
        jsr (a2)                However, if SuperBASIC should move then,
;                               occasionally, there will be a wrong result
        beq.s found

        tst.l d1
        bne.s loop

not_found
        moveq #-7,d6

found
        moveq #3,d0
        add.w (a6,a3.l),d0
        bclr #0,d0
        lea.l (a3,d0.w),a1
        move.l a1,sb_arthp(a6)

        bra l2frtrd6

err_bp
        moveq #-15,d0
exit
        rts

*
        end
